<?php
 
class SimpleImage {
   
   var $image;
   var $image_type;
 
   function load($filename) {
      $image_info = getimagesize($filename);
      $this->image_type = $image_info[2];
      if( $this->image_type == IMAGETYPE_JPEG ) {
         $this->image = imagecreatefromjpeg($filename); 
      } elseif( $this->image_type == IMAGETYPE_GIF ) {
         $this->image = imagecreatefromgif($filename);
      } elseif( $this->image_type == IMAGETYPE_PNG ) {
         $this->image = imagecreatefrompng($filename);
      }
	 
   }
   function save($filename, $image_type=IMAGETYPE_JPEG, $compression=250, $permissions=null) {
      if( $image_type == IMAGETYPE_JPEG ) {
         imagejpeg($this->image,$filename,$compression);
      } elseif( $image_type == IMAGETYPE_GIF ) {
         imagegif($this->image,$filename);         
      } elseif( $image_type == IMAGETYPE_PNG ) {
         imagepng($this->image,$filename);
      }   
      if( $permissions != null) {
         chmod($filename,$permissions); 
      }   
   }
   
   

   function output($image_type=IMAGETYPE_JPEG) {
      if( $image_type == IMAGETYPE_JPEG ) {
         imagejpeg($this->image);
      } elseif( $image_type == IMAGETYPE_GIF ) {
         imagegif($this->image);         
      } elseif( $image_type == IMAGETYPE_PNG ) {
         imagepng($this->image);
      }   
   }
   function getWidth() {
      return imagesx($this->image);
   }
   function getHeight() {
      return imagesy($this->image);
   }
   function resizeToHeight($height) {
      $ratio = $height / $this->getHeight();
      $width = $this->getWidth() * $ratio;
      $this->resize($width,$height);
   }
   function resizeToWidth($width) {
      $ratio = $width / $this->getWidth();
      $height = $this->getheight() * $ratio;
      $this->resize($width,$height);
   }
   function scale($scale) {
      $width = $this->getWidth() * $scale/100;
      $height = $this->getheight() * $scale/100; 
      $this->resize($width,$height);
   }
   function resize($width,$height) {
      $new_image = imagecreatetruecolor($width, $height);
      imagecopyresampled($new_image, $this->image, 0, 0, 0, 0, $width, $height, $this->getWidth(), $this->getHeight());
      $this->image = $new_image;   
   }  
}

function skaluj($src,$format,$co,$wymiar,$sciezka)
{
switch ($format)
{
case 'jpg': $img_src=imagecreatefromjpeg($src); break;
case 'png': $img_src=imagecreatefrompng($src); break;
case 'gif': $img_src=imagecreatefromgif($src); break;
}
$x=imagesx($img_src); 
$y=imagesy($img_src); 

if ($co=='x') $ile = $x/$wymiar;
else if ($co=='y') $ile = $y/$wymiar;
else if ($co=='xy')
{
if ($x > $y) 
{ 
$ile = $x/$wymiar; 
}
else 
{ 
$ile = $y/$wymiar; 
}
}
else if ($co=='crop_x') $ile = $x/$wymiar[0];
else if ($co=='crop_y') $ile = $y/$wymiar[1];

if ($co=='fixed')
{
$x2 = $wymiar[0]; 
$y2 = $wymiar[1];
}
else
{
$x2 = $x/$ile; 
$y2 = $y/$ile;
}

$img_dst=imagecreatetruecolor($x2,$y2);

imagecopyresampled($img_dst,$img_src,0,0,0,0,$x2,$y2,$x,$y);


if ($co=='crop_x')
{
if (!$wymiar[2]||($y2<$wymiar[1])) $posy = $y2/2-$wymiar[1]/2;
else if ($wymiar[2]=='tl') $posy = 0;
else if ($wymiar[2]=='br') $posy = $y2-$wymiar[1];

$img_dst2 = imagecreatetruecolor($wymiar[0],$wymiar[1]);

imagecopyresampled($img_dst2,$img_dst,0,0,0,$posy,$wymiar[0],$wymiar[1],$wymiar[0],$wymiar[1]);

if ($y2<$wymiar[1])
{
imagefill($img_dst2, 0, 0, imagecolorallocate($img_dst2, 255, 255, 255));
imagefill($img_dst2, $wymiar[0]-1, 0, imagecolorallocate($img_dst2, 255,
255, 255));
}

}
else if ($co=='crop_y')
{
$posx = $x2/2-$wymiar[0]/2;
$img_dst2 = imagecreatetruecolor($wymiar[0],$wymiar[1]);

imagecopy($img_dst2,$img_dst,0,0,$posx,0,$wymiar[0],$wymiar[1]);

if ($x2<$wymiar[0])
{
imagefill($img_dst2, 0, 0, imagecolorallocate($img_dst2, 255, 255, 255));
imagefill($img_dst2, $wymiar[0]-1, 0, imagecolorallocate($img_dst2, 255,
255, 255));
}
}
else $img_dst2 = $img_dst;


switch ($format)
{
case 'jpg': imagejpeg($img_dst2,$sciezka,80); break;
case 'png': imagepng($img_dst2,$sciezka); break;
case 'gif': imagegif($img_dst2,$sciezka); break;
}

imagedestroy($img_src);
imagedestroy($img_dst);
}


//jezeli skalujes typem ($co) x,y lub xy to podajesz jeden wymiar
//jezeli skalujesz typem fixed,crop_x lub crop_y to podajesz array(wymiar_x,wymiar_y)

?>